'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 



Imports Phidget22
Imports Phidget22.Events

Public Class Form1
    Dim WithEvents device As Phidget22.PowerGuard
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox


    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        fanCombo.DataSource = [Enum].GetValues(GetType(FanMode))
        fanCombo.SelectedIndex = -1
        errorBox = New ErrorEventBox(Me)
        device = New Phidget22.PowerGuard()

        open.openCmdLine(device)
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Application.DoEvents()
        If device.Attached Then
            device.Close()
        End If
    End Sub


    Private Sub powerGuard_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.AttachEventArgs) Handles device.Attach
        PhidgetInfoBox1.FillPhidgetInfo(CType(sender, Phidget))

        settingsBox.Visible = True

        Try
            fanCombo.SelectedIndex = 0
            overVoltageTrk.Minimum = device.MinOverVoltage
            overVoltageTrk.Maximum = device.MaxOverVoltage
            overVoltageTrk.Value = device.MinOverVoltage
            overVoltageTxt.Text = overVoltageTrk.Value.ToString() + "V"
            device.OverVoltage = device.MinOverVoltage
            enablechk.Checked = device.PowerEnabled
        Catch ex As PhidgetException
            errorBox.addMessage("Error initializing device: " + ex.Message)
        End Try
    End Sub

    Private Sub powerGuard_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.DetachEventArgs) Handles device.Detach
        PhidgetInfoBox1.Clear()
        settingsBox.Visible = False
    End Sub

    Private Sub powerGuard_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errTxt.Text = e.Description
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub overVoltageTrk_Scroll(sender As Object, e As EventArgs) Handles overVoltageTrk.Scroll
        Try
            device.OverVoltage = overVoltageTrk.Value
            overVoltageTxt.Text = device.OverVoltage.ToString() + "V"
        Catch ex As PhidgetException
            errorBox.addMessage(ex.Message)
        End Try
    End Sub

    Private Sub enablechk_CheckedChanged(sender As Object, e As EventArgs) Handles enablechk.CheckedChanged
        Try
            device.PowerEnabled = enablechk.Checked
        Catch ex As Exception
            errorBox.addMessage(ex.ToString())
        End Try
    End Sub

    Private Sub fanCombo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles fanCombo.SelectedIndexChanged
        If CType(sender, ComboBox).SelectedIndex = -1 Or device Is Nothing Then
            Return
        End If
        Try
            device.FanMode = CType([Enum].Parse(GetType(FanMode), fanCombo.SelectedValue.ToString()), FanMode)
        Catch ex As Exception
            errorBox.addMessage("Error setting fan mode: " + ex.Message)
        End Try

    End Sub
End Class



